/******************************************************************
  Non-Clausal DPLL Solver
  Version: 2.5

  Christian Thiffault
  University of Toronto
  October 18th 2003 (April 2004)

  *****************************************************************

   Propagate.h

   Contains the definition of functions that are used to propagate
   a node assignment to its children and parents (as well as
   nogoods).

  *****************************************************************/

#ifndef __PROPAGATE_H__
#define __PROPAGATE_H__

#include "noclause.h"
#include "uniquestack.h"



/************************** Constants *****************************/
/******************* Structure Declarations ***********************/
/*************************** Macros *******************************/
/********************** Global Variables **************************/

 // Variables for the propagation stack
extern int *g_propagation_stack;
extern int g_stack_top;

 // Object for the DC propagation stack
extern UniqueStack *g_dcstack;





/********************** Inline Functions **************************/

 // Add a node to the variables awaiting to be propagated
void inline Propagate_Add(int node) {
  g_propagation_stack[g_stack_top++] = node;
}


 // Remove all the nodes in the stacks (used if we found a conflict)
void inline Propagate_Empty() {
  g_stack_top = 0;
  if (g_args.dcpropagation == TRUE)
    g_dcstack->empty();
}




/********************** Extern Functions **************************/

extern void Propagate_Initialize();
extern void Propagate_Free();
extern int  Propagate_Propagate();



#endif
