/******************************************************************
  Non-Clausal DPLL Solver
  Version: 2.5

  Christian Thiffault
  University of Toronto
  October 18th 2003 (April 2004)
  
  *****************************************************************

  Stats.h

  Contains the declaration of the functions required to take
  statistical information throughout the program, and output this
  information in various forms.

  *****************************************************************/


#ifndef __STATS_H__
#define __STATS_H__

#include "noclause.h"
#include <time.h>

#ifdef WIN32
#include <windows.h>
#else /* WIN32 */
#include <sys/times.h>
#include <unistd.h>
#endif /* WIN32 */



/************************** Constants *****************************/
#define STATS_PARSING    1
#define STATS_MERGING    2
#define STATS_COMPACT    3
#define STATS_SOLVER     4
#define STATS_DEBUG1     5
#define STATS_DEBUG2     6
#define STATS_DEBUG3     7


/******************* Structure Declarations ***********************/
/********************** Global Variables **************************/
/************************* Inline Functions ***********************/
/****************** External Function Declarations ****************/

extern void Stats_Initialize();
extern void Stats_PrintResults();
extern void Stats_PrintLine(char *filename);
extern void Stats_PrintParseLine(char *filename);

extern void Stats_StartTimer(int timed_region);
extern void Stats_StopTimer(int timed_region);


#endif

